<?php
if (!defined('grasshoppers.php')) {
    exit;
}

function get_order_details($order_id)
{
    if (!$order_id)
        return;

    // Allow code execution only once 
    if (!get_post_meta($order_id, '_thankyou_action_done', true)) {

        $order = wc_get_order($order_id);

        $options = ghcod_get_options();

        $available_payment_methods = WC()->payment_gateways->get_available_payment_gateways();
        $sendData = FALSE;
        foreach ($available_payment_methods as $method) {
            if (str_replace(' ', '_', $order->get_payment_method_title()) == str_replace(' ', '_', $method->get_title()));
            if ($options[str_replace(' ', '_', $method->get_title())] == 'on') {
                $sendData = TRUE;
                break;
            }
        }

        //Excute only when payment method == cod checked($options[$name] == 'on')
        if ($sendData) {

            /* Code Start */

            //$options['ghcod_live_cooporate_id']
            //Test Key - ZLVQ46D7KNPERGW

            $item_id = array();
            $item_name = array();
            $item_qty = array();

            foreach ($order->get_items() as $item_id => $item) {

                $item_id[] = $item->get_product_id();
                $item_name[] = $item->get_name();
                $item_qty[] = intval($item->get_quantity());
            }

            $live_url = ': http://www.grasshoppers.lk/customers/WebService/createDeliveryRequest';
            $body = array(
                'corporateId' => $options['ghcod_live_cooporate_id'],
                'customerOrderReferenceNo' => $order_id,
                'pickupStreet' => $options['ghcod_pickup_street'],
                'pickupCity' => $options['ghcod_pickup_city'],
                'pickupZipCode' => $options['ghcod_pickup_zipcode'],
                'pickupLatitude' => 0,
                'pickupLongitude' => 0,
                'recipientName' => $order->get_shipping_first_name(),
                'recipientContactNo' => $order->get_billing_phone(),
                'recipientContactNo2' => 'N/A',
                'deliverStreet' => $order->get_shipping_address_1(),
                'deliverCity' => $order->get_shipping_city(),
                'deliveryZipCode' => $order->get_shipping_postcode(),
                'deliverLatitude' => 0,
                'deliverLongitude' => 0,
                'deliveryMethod' => 'Standard',
                'scaleValue' => 2,
                'paymentType' => 'CASH_ON_DELIVERY',
                'priceCOD' => $order->get_total(),
                'itemDetailList' =>

                implode(',', array($item_id => array('title' => $item_name, 'quantity' => $item_qty))),
            );

            $raw_response = wp_remote_post(
                $live_url,
                array(
                    'headers' => array('Content-Type' => 'application/json'),
                    'timeout' => 30,
                    'body' => json_encode($body),
                )
            );

            plugin_log($raw_response);
            plugin_log(json_encode($body) . '\n');

            /*
        //Excute only when payment method == cod
        if($order->get_payment_method() == 'cod') {
        
            
        $order_key = $order->get_order_key();

        $order_key = $order->get_order_number();

        if($order->is_paid())
            $paid = __('yes');
        else
            $paid = __('no');

        foreach ( $order->get_items() as $item_id => $item ) {

            $product = $item->get_product();
            $product_id = $product->get_id();
            $product_id = $item->get_name();
        }
        
        echo '
        <p>
        Order ID: '. $order_id . 
        ' — Order Status: ' . $order->get_status() . 
        ' — Order is paid: ' . $paid . 
        ' — Method: ' . $order->get_payment_method() . 
        
        '</p>';
        
        */

            /* Code End */

            // Flag the action as done (to avoid repetitions on reload for example)
            $order->update_meta_data('_thankyou_action_done', true);
            $order->save();
        }
    }
}
